#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <time.h>
#include <string.h>
#include <assert.h>


void benchmark(int64_t N, int64_t R)
{
	  /* Initialization*/
    int64_t *tab = (int64_t *) malloc( N *sizeof(int64_t) );
    assert(tab != NULL);
    
    int64_t i;
    for(i=0; i<N; i++)
    {
        tab[i]=i; 
    }

    srandom(clock());

		/* Insert the shuffle here*/
    
    /* Now we begin the timing */
    int64_t start=clock();

		/* Outer loop: repeat the measure R times */
    for(int64_t r=0; r<R; r++)
    {
				/* The inner loop that walks the list */ 
        int64_t p=0;
        while( tab[p] != 0)
        {
            p = tab[p];
        }
    }
    int64_t end=clock();
		
		/* Multiplication by 1e9 to have a number in ns */
    double duration=1.0e9*(end-start)/CLOCKS_PER_SEC/R;
		
    printf("%ld %g", N*sizeof(int64_t), duration/N);
    printf("       #");
    printf(" R=%ld",R);
    printf("   N=%ld",N);
    printf("\n");
    
}



int main()
{
	int64_t R=100000; /* number of repeats of the test */
    
	printf("# bytes    ns/byte\n");
	
	int64_t N=10;
		
	benchmark(N, R);
	
	return 0;
}
